/* $Id: dirc.c,v 1.3 2000/09/04 08:19:07 rousseau Exp $ */
#include <stdio.h>

#include "reader.h"

#ifndef WIN32
#define DEVICE "/dev/screader"
#else
#define DEVICE "COM1"
#endif

#define BUF_SIZE 300

#define ISO       0x00
#define SELFIL    0xA4
#define P1_SELDF  0x01
#define P1_SELMF  0x03
#define P2_SELFIL 0x00

int main(int argc, char *argv[])
{
	unsigned char buf[BUF_SIZE];
	int length;
	unsigned char SW1,SW2;
	ReaderDesc rd;
	char* _progname;
	int i,j;

	setvbuf(stdout, (char *)NULL, _IONBF, 0);
	setvbuf(stderr, (char *)NULL, _IONBF, 0);

	_progname = argv[0];

	if (InitReader(&rd, TLP, DEVICE) == -1)
		return -1;

	if ((length = ResetCardBinary(&rd,buf,BUF_SIZE)) == -1)
	{
		fprintf(stderr,"%s : Reset Binary Failed : %d\n", _progname, 
			GetRerrno());
		exit(1);
	}

	printf("[0000]");

	for (i=0x00 ; i != 0x100 ; i++)
	{
		for (j=0x00 ; j != 0x100 ; j++) 
		{ 
			printf("\b\b\b\b\b\b[%.2X%.2X]",i,j);
			buf[0] =  (unsigned char) i; 
			buf[1] =  (unsigned char) j;

			if (SendIncomingAPDUBinary (&rd, ISO, SELFIL, P1_SELDF, P2_SELFIL,
				0x02, buf, &SW1, &SW2) == -1)
			{
				fprintf(stderr,"%s : SelFil DF error : %d\n", _progname,
					GetRerrno());
				exit(1);
			}

			if (SW1 == 0x6A && SW2 == 0x82)
				;
			else
			{
				printf("\nOK pour %02X%02X. Status = %02X%02X %s\n[%02X%02X]",
					i, j, SW1, SW2, ISO7816_ErrorStr(SW1, SW2), i, j);
				
				if (SendIncomingAPDUBinary (&rd, ISO, SELFIL, P1_SELMF,
					P2_SELFIL, 0x00, NULL, &SW1, &SW2) == -1)
					{
						fprintf(stderr,"%s : SelFil MF error : %d\n",
							_progname, GetRerrno());
						exit(1);
					}

				printf("SelFil MF. Status = %02X%02X\n[%02X%02X]", SW1, SW2,
					i, j);	
			}
		}	
	}  

	return 0;
	CloseReader(&rd);
}



/*
* [0100]
* OK pour 0100. Status = 611A
*
* [0100]SelFil MF. Status = 6112
*/

