/* $Id: testreader-local.c,v 1.1 2000/09/04 13:45:48 rousseau Exp $ */
#include <stdio.h>

#include "reader.h"

#ifndef WIN32
#define DEVICE "/dev/ttyS0"
#else
#define DEVICE "COM1"
#endif

#define ERROR_TEXT_SIZE 30
#define DEVICENAME_SIZE FILENAME_MAX

int main(void)
{
	ReaderDesc desc;
	char device[DEVICENAME_SIZE];
	char buffer[ATR_BUF_SIZE];
	int ret;

	printf("smartcard device [%s]: ", DEVICE);
	fgets(device, DEVICENAME_SIZE, stdin);

	/* remove the \n */
	device[strlen(device)-1] = '\0';
	if (strlen(device) == 0)
		strcpy(device, DEVICE);

	printf("InitReader\n");
	ret = InitReader(&desc, TLP, device);
	printf("ret: %d, rerrno %d\n", ret, GetRerrno());
	printf("InitReader: %s\n", GetRerrStr(GetRerrno()));
	perror("InitReader");
	if (ret < 0)
		return 1;

	printf("\nResetCardAscii\n");
	ret = ResetCardAscii(&desc, buffer, ATR_BUF_SIZE);
	printf("ATR: %s\n", buffer);
	printf("ret: %d, rerrno %d\n", ret, GetRerrno());
	printf("ResetCardAscii: %s\n", GetRerrStr(GetRerrno()));
	perror("ResetCardAscii");

	printf("\nPowerDown\n");
	ret = PowerDown(&desc);
	printf("ret: %d, rerrno %d\n", ret, GetRerrno());
	printf("PowerDown: %s\n", GetRerrStr(GetRerrno()));
	perror("PowerDown");

	printf("\nCloseReader\n");
	CloseReader(&desc);
	printf("ret: %d, rerrno %d\n", ret, GetRerrno());
	printf("CloseReader: %s\n", GetRerrStr(GetRerrno()));
	perror("CloseReader");

	return 0;
} /* main */

