/* $Id: testreader.c,v 1.4 2000/09/04 08:19:07 rousseau Exp $ */
#include <stdio.h>

#include "reader.h"

#ifndef WIN32
#define DEVICE "/dev/screader"
#else
#define DEVICE "COM1"
#endif

#define ERROR_TEXT_SIZE 30

int main(void)
{
	ReaderDesc desc;
	char buffer[ATR_BUF_SIZE];
	int ret;

	printf("InitReader\n");
	ret = InitReader(&desc, TLP, DEVICE);
	printf("ret: %d, rerrno %d\n", ret, GetRerrno());
	printf("InitReader: %s\n", GetRerrStr(GetRerrno()));
	perror("InitReader");
	if (ret < 0)
		return 1;

	printf("\nResetCardAscii\n");
	ret = ResetCardAscii(&desc, buffer, ATR_BUF_SIZE);
	printf("ATR: %s\n", buffer);
	printf("ret: %d, rerrno %d\n", ret, GetRerrno());
	printf("ResetCardAscii: %s\n", GetRerrStr(GetRerrno()));
	perror("ResetCardAscii");

	printf("\nPowerDown\n");
	ret = PowerDown(&desc);
	printf("ret: %d, rerrno %d\n", ret, GetRerrno());
	printf("PowerDown: %s\n", GetRerrStr(GetRerrno()));
	perror("PowerDown");

	printf("\nCloseReader\n");
	CloseReader(&desc);
	printf("ret: %d, rerrno %d\n", ret, GetRerrno());
	printf("CloseReader: %s\n", GetRerrStr(GetRerrno()));
	perror("CloseReader");

	printf("\nThe driver is now closed. The following command should return an error.");
	
	printf("\nResetCardAscii\n");
	ret = ResetCardAscii(&desc, buffer, ATR_BUF_SIZE);
	printf("ATR: %s\n", buffer);
	printf("ret: %d, rerrno %d\n", ret, GetRerrno());
	printf("ResetCardAscii: %s\n", GetRerrStr(GetRerrno()));
	perror("ResetCardAscii");

	return 0;
} /* main */

